#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
#include <Magick++.h>

void eraseAllSubStr(std::string & mainStr, const std::string & toErase) {
	size_t pos = std::string::npos;

	while ((pos  = mainStr.find(toErase) )!= std::string::npos) {
		mainStr.erase(pos, toErase.length());
	}
}

int main(int argc,char **argv) {
	using namespace std;
	using namespace Magick; 

	string line;
	unsigned char comma;
	string tmpVal;
	string tmpVal2;
	vector<string> filenames;
	vector<int> spriteOffsetsX;
	vector<int> spriteOffsetsY;
	vector<unsigned> spriteSizesX;
	vector<unsigned> spriteSizesY;
	vector<unsigned> spriteSourceSizesX;
	vector<unsigned> spriteSourceSizesY;
	vector<unsigned> textureRectsPosX;
	vector<unsigned> textureRectsPosY;
	vector<unsigned> textureRectsSizeX;
	vector<unsigned> textureRectsSizeY;
	vector<bool> textureRotateds;
	
	string filename = argv[1];
	
	ifstream myfile (filename + ".plist");
	if (myfile.is_open()) {
		while (getline(myfile,line)) {
			line.erase(remove(line.begin(), line.end(), '\r'), line.end());
			eraseAllSubStr(line, "    ");
			if (line.find(".png</key>") != string::npos) {
			
				//name
				line.erase(0,5).erase(line.length() - 6, 6);
				filenames.push_back (line);
				
				//spriteOffset
				getline(myfile, line);getline(myfile, line);getline(myfile, line);getline(myfile, line);getline(myfile, line);
				line.erase(remove(line.begin(), line.end(), '\r'), line.end());
				eraseAllSubStr(line, "    ");
				line.erase(0,9).erase(line.length() - 10, 10);
				comma = line.find(",");
				tmpVal = line;
				spriteOffsetsX.push_back(stoi(tmpVal.erase(comma, line.length() - comma)));
				spriteOffsetsY.push_back(stoi(line.erase(0, comma + 1)));
				
				//spriteSize
				getline(myfile, line);getline(myfile, line);
				line.erase(remove(line.begin(), line.end(), '\r'), line.end());
				eraseAllSubStr(line, "    ");
				line.erase(0,9).erase(line.length() - 10, 10);
				comma = line.find(",");
				tmpVal = line;
				spriteSizesX.push_back(stoul(tmpVal.erase(comma, line.length() - comma)));
				spriteSizesY.push_back(stoul(line.erase(0, comma + 1)));
				
				//spriteSourceSize
				getline(myfile, line);getline(myfile, line);
				line.erase(remove(line.begin(), line.end(), '\r'), line.end());
				eraseAllSubStr(line, "    ");
				line.erase(0,9).erase(line.length() - 10, 10);
				comma = line.find(",");
				tmpVal = line;
				spriteSourceSizesX.push_back(stoul(tmpVal.erase(comma, line.length() - comma)));
				spriteSourceSizesY.push_back(stoul(line.erase(0, comma + 1)));
				
				//textureRect
				getline(myfile, line);getline(myfile, line);
				line.erase(remove(line.begin(), line.end(), '\r'), line.end());
				eraseAllSubStr(line, "    ");
				line.erase(0,9).erase(line.length() - 10, 10);
				comma = line.find(",");
				line[comma] = '\'';
				comma = line.find(",");
				
				tmpVal = line;
				tmpVal.erase(comma, tmpVal.length() - comma);
				tmpVal.erase(0, 1).erase(tmpVal.length() - 1, 1);
				comma = tmpVal.find("'");
				tmpVal2 = tmpVal;
				textureRectsSizeX.push_back(stoul(tmpVal2.erase(comma, tmpVal2.length() - comma)));
				textureRectsSizeY.push_back(stoul(tmpVal.erase(0, comma + 1)));
				comma = line.find(",");
				
				tmpVal = line;
				tmpVal.erase(0, comma);
				tmpVal.erase(0,2).erase(tmpVal.length() - 1, 1);
				comma = tmpVal.find(",");
				tmpVal2 = tmpVal;
				textureRectsPosX.push_back(stoul(tmpVal2.erase(comma, tmpVal2.length() - comma)));
				textureRectsPosY.push_back(stoul(tmpVal.erase(0, comma + 1)));
				
				//textureRotated
				getline(myfile, line);getline(myfile, line);
				line.erase(remove(line.begin(), line.end(), '\r'), line.end());
				eraseAllSubStr(line, "    ");
				line.erase(0,1).erase(line.length() - 2, 2);
				if (line == "true") {
					textureRotateds.push_back(true);
				} else {
					textureRotateds.push_back(false);
				}
			}
		}

		myfile.close();

		int systemRet = system(("mkdir " + filename).c_str());
		if(systemRet == -1){}

		InitializeMagick(*argv);
		
		Image origImage;
		Image image;
		try {
			origImage.read(filename + ".png");
			for (unsigned i = 0; i < filenames.size(); i++) {
				image = origImage;
				if (textureRotateds[i]) {
					image.crop(Geometry(textureRectsPosY[i], textureRectsPosX[i], textureRectsSizeX[i], textureRectsSizeY[i]));
					image.rotate(-90);
				} else {
					image.crop(Geometry(textureRectsPosX[i], textureRectsPosY[i], textureRectsSizeX[i], textureRectsSizeY[i]));
				}
				image.backgroundColor("transparent");
				image.extent(Geometry(spriteSourceSizesX[i], spriteSourceSizesY[i]), CenterGravity);
				if (spriteOffsetsX[i] < 0) {
					spriteOffsetsX[i] = spriteSourceSizesX[i] * 2 - spriteOffsetsX[i];
				}
				if (spriteOffsetsY[i] < 0) {
					spriteOffsetsY[i] = (spriteSourceSizesY[i] + spriteOffsetsY[i]);
				}
				image.roll(spriteOffsetsX[i], spriteOffsetsY[i]);
				image.repage();
				
				if (filenames[i].find('/') != string::npos) {
					size_t pos = 0;
					string token;
					string dir;
					while ((pos = filenames[i].find("/")) != string::npos) {
						token = filenames[i].substr(0, pos);
						dir+=token + "/";
						filenames[i].erase(0, pos + 1);
					}
					int systemRet = system(("mkdir -p " + filename + "/" + dir).c_str());
					if(systemRet == -1){}
					image.write(filename + "/" + dir + filenames[i]);
				} else {
					image.write(filename + "/" + filenames[i]);
				}
			}
		} 
		catch(Exception &error_) { 
			cout << "Caught exception: " << error_.what() << endl; 
			return 1; 
		}
	
	} else {
		cout << "Error opening file.";
	}
	
	return 0;
}
